Bug 648326 - repoquery --requires --resolve does not work properly with multilib.
repoquery --requires --resolve does not work properly with multilib.
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: yum-utils (Show other bugs)
13
Unspecified Unspecified
low Severity medium
: ---
: ---
Assigned To: Seth Vidal
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-10-31 22:22 EDT by Andrew J. Schorr
Modified: 2014-01-21 18:16 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-06-28 06:59:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Andrew J. Schorr 2010-10-31 22:22:40 EDT
Description of problem: repoquery --requires --resolve does not give correct results.


Version-Release number of selected component (if applicable):
yum-utils-1.1.28-1.fc13

How reproducible:
On an x86_64 Fedora 13 system, use repoquery to find rpms required to install postgresql.x86_64




Steps to Reproduce:
1. repoquery -R --resolve postgresql.x86_64
2.
3.
  
Actual results:
-bash-4.1# uname -a
Linux ti93 2.6.34.6-54.fc13.x86_64 #1 SMP Sun Sep 5 17:16:27 UTC 2010 x86_64 x86_64 x86_64 GNU/Linux
-bash-4.1# repoquery -R --resolve postgresql.x86_64
postgresql-0:8.4.5-1.fc13.x86_64
glibc-0:2.12.1-4.i686
zlib-0:1.2.3-23.fc12.x86_64
openssl-0:1.0.0-1.fc13.x86_64
postgresql-libs-0:8.4.5-1.fc13.i686
initscripts-0:9.12-1.fc13.x86_64
readline-0:6.1-2.fc13.x86_64




Expected results:
I expect it to depend on postgresq-libs.x86_64, not .i686.

-bash-4.1# repoquery -R postgresql.x86_64 | grep libpq
libpq.so.5()(64bit)

-bash-4.1# repoquery --whatprovides 'libpq.so.5()(64bit)'
postgresql-libs-0:8.4.5-1.fc13.x86_64
postgresql-libs-0:8.4.3-1.fc13.x86_64

So how does --resolve come up with the i686 library rpm instead of x86_64?




Additional info:
Comment 1 James Antill 2010-11-01 09:07:03 EDT
The problem is that we assume that a pkg. will only dep. on a single arch, so whichever arch. is resolved to last wins. Fixed upstream:


% repoquery -R --resolve postgresql.x86_64
postgresql-0:8.4.5-1.fc13.x86_64
postgresql-libs-0:8.4.5-1.fc13.x86_64
postgresql-libs-0:8.4.5-1.fc13.i686
readline-0:6.1-2.fc13.x86_64
openssl-0:1.0.0-1.fc13.x86_64
initscripts-0:9.12-1.fc13.x86_64
glibc-0:2.12.1-4.i686
zlib-0:1.2.3-23.fc12.x86_64
glibc-0:2.12-1.x86_64

...the reason "postgresql-libs-0:8.4.5-1.fc13.i686" is considered at all is because of this dep. "postgresql-libs = 8.4.5-1.fc13".
Comment 2 Andrew J. Schorr 2010-11-01 11:26:03 EDT
Thanks, that makes sense.  But in cases where more than one rpm supplies a given capability, would it not be reasonable for repoquery to give preference to rpms whose architecture matches the architecture of the package being queried?
In other words, if I am trying to resolve the requirements of postgresql.x86_64, and certain dependencies may be satisfied by either foo.i686 or foo.x86_64, shouldn't we automatically give preference to the .x86_64 provider?
Comment 3 James Antill 2010-11-01 13:14:51 EDT
 yum itself has a lot "intelligence" here, so it will never install postgresql-libs.i686 in any normal cases.
 However repoquery just treats each dep. as it's own thing, and prints all the providers. This is somewhat worse in some cases, like this, but generally better overall for the things people use repoquery for.
Comment 4 Bug Zapper 2011-05-30 10:26:24 EDT
This message is a reminder that Fedora 13 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 13.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '13'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 13's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 13 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2011-06-28 06:59:39 EDT
Fedora 13 changed to end-of-life (EOL) status on 2011-06-25. Fedora 13 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.